--------------------------------------------------------------------------------------------
-- 
-- DSP Builder (Version 6.0, Build 202)
-- Quartus II development tool and MATLAB/Simulink Interface
-- 
-- Legal Notice:  2001 Altera Corporation. All rights reserved.  Your use of Altera  
-- Corporation's design tools, logic functions and other software and tools, and its  
-- AMPP partner logic functions, and any output files any of the foregoing            
-- (including device programming or simulation files), and any associated             
-- documentation or information are expressly subject to the terms and conditions     
-- of the Altera Program License Subscription Agreement, Altera MegaCore Function     
-- License Agreement, or other applicable license agreement, including, without       
-- limitation, that your use is for the sole purpose of programming logic devices     
-- manufactured by Altera and sold by Altera or its authorized distributors.          
-- Please refer to the applicable agreement for further details.                      
--
--
-- Time Stamp: Tue Aug 29 15:24:14 2006

--------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

library dspbuilder;
use dspbuilder.dspbuilderblock.all;

library lpm;
use lpm.lpm_components.all;

Entity muxDemo is 
	Port(
		clock		:	in std_logic;
		sclrp 		:	in std_logic:='0';		
		AltBus10Bit		:	out std_logic_vector(9 downto 0);
		BitAltBus5_10bit		:	out std_logic_vector(9 downto 0);
		SelectPower24BitSELECT		:	out std_logic_vector(3 downto 0);
		UnsgnInt4BitSELECT		:	out std_logic_vector(3 downto 0)
	    );
end muxDemo;

architecture aDspBuilder of muxDemo is


signal	SASelectPower24BitSELECTO		:	std_logic_vector(3 downto 0);
signal	SAUnsgnInt4BitSELECTO		:	std_logic_vector(3 downto 0);
signal sclr 		:	std_logic:='0';
signal	A0W		:	std_logic_vector(7 downto 0);
signal	A1W		:	std_logic_vector(9 downto 0);
signal	A2W		:	std_logic_vector(9 downto 0);
signal	A3W		:	std_logic_vector(7 downto 0);
signal	A4W		:	std_logic_vector(9 downto 0);
signal	A5W		:	std_logic_vector(9 downto 0);
signal	A6W		:	std_logic_vector(9 downto 0);
signal	A7W		:	std_logic_vector(9 downto 0);
signal	selectbus4bit		:	std_logic_vector(4 downto 0);
signal	A9W		:	std_logic_vector(9 downto 0);
signal	A10W		:	std_logic_vector(9 downto 0);
signal	A11W		:	std_logic;
signal	A12W		:	std_logic;
signal	A13W		:	std_logic;
signal	A14W		:	std_logic;
signal	unsignedintegerbusselect4bit		:	std_logic_vector(4 downto 0);
signal datasub13_0Mux		:	std_logic_vector(9 downto 0);
signal datasub13_1Mux		:	std_logic_vector(9 downto 0);
signal datasub13_2Mux		:	std_logic_vector(9 downto 0);
signal datasub13_3Mux		:	std_logic_vector(9 downto 0);
signal data_13_muxin		:	std_logic_vector(39 downto 0);
signal Sel_13_Mux		:	std_logic_vector(1 downto 0);
signal datasub14_0Mux		:	std_logic_vector(9 downto 0);
signal datasub14_1Mux		:	std_logic_vector(9 downto 0);
signal datasub14_2Mux		:	std_logic_vector(9 downto 0);
signal datasub14_3Mux		:	std_logic_vector(9 downto 0);
signal data_14_muxin		:	std_logic_vector(39 downto 0);
signal Sel_14_Mux		:	std_logic_vector(3 downto 0);



Begin

assert (1<0)  report altversion severity Note;


-- Output - I/O assignment from Simulink Block  "AltBus10Bit"
AltBus10Bit		<=	A9W;

-- Output - I/O assignment from Simulink Block  "BitAltBus5_10bit"
BitAltBus5_10bit		<=	A10W;
SelectPower24BitSELECT		<=	SASelectPower24BitSELECTO;
UnsgnInt4BitSELECT		<=	SAUnsgnInt4BitSELECTO;

-- Global reset circuitry for the input global reset sclrp
sclr		<=	sclrp;

-- Constant assignment - Simulink Block "AltBus1"
A0W(7 downto 0)		<=	"00000001";

-- Constant assignment - Simulink Block "AltBus2"
A1W(9 downto 0)		<=	"1111111110";

-- Constant assignment - Simulink Block "AltBus3"
A2W(9 downto 0)		<=	"0000000011";

-- Constant assignment - Simulink Block "AltBus6"
A3W(7 downto 0)		<=	"00001010";

-- Constant assignment - Simulink Block "AltBus7"
A4W(9 downto 0)		<=	"0000010100";

-- Constant assignment - Simulink Block "AltBus8"
A5W(9 downto 0)		<=	"0000011110";

-- Constant assignment - Simulink Block "Constant1_10_Bit_signed"
A6W(9 downto 0)		<=	"0000101000";

-- Constant assignment - Simulink Block "Constant_10_Bit_signed"
A7W(9 downto 0)		<=	"0000000100";

-- Bus Construction - Simulink Block "BusBuild"
selectbus4bit(0)		<=	A11W;
selectbus4bit(1)		<=	A12W;
selectbus4bit(2)		<=	A13W;
selectbus4bit(3)		<=	A14W;
selectbus4bit(4)		<=	'0';
datasub13_0Mux(7 downto 0)		<=	A0W(7 downto 0);
datasub13_0Mux(8)		<=	A0W(7);
datasub13_0Mux(9)		<=	A0W(7);
datasub13_1Mux		<=	A1W;
datasub13_2Mux		<=	A2W;
datasub13_3Mux		<=	A7W;
data_13_muxin		<=	datasub13_3Mux & datasub13_2Mux & datasub13_1Mux & datasub13_0Mux;
Sel_13_Mux(1 downto 0)		<=	unsignedintegerbusselect4bit(1 downto 0);
datasub14_0Mux(7 downto 0)		<=	A3W(7 downto 0);
datasub14_0Mux(8)		<=	A3W(7);
datasub14_0Mux(9)		<=	A3W(7);
datasub14_1Mux		<=	A4W;
datasub14_2Mux		<=	A5W;
datasub14_3Mux		<=	A6W;
data_14_muxin		<=	datasub14_3Mux & datasub14_2Mux & datasub14_1Mux & datasub14_0Mux;
Sel_14_Mux(3 downto 0)		<=	selectbus4bit(3 downto 0);
unsignedintegerbusselect4bit(4)		<=	'0';



-- Output - I/O assignment from Simulink Block  "SelectPower24BitSELECT"
SelectPower24BitSELECTi : SBF generic map(
				width_inl=>5,
				width_inr=>0,
				width_outl=>4,
				width_outr=>0,
				lpm_signed=>BusIsUnsigned,
				round=>0,
				satur=>0)
		port map (
				xin=>selectbus4bit,
				yout=>SASelectPower24BitSELECTO);


-- Output - I/O assignment from Simulink Block  "UnsgnInt4BitSELECT"
UnsgnInt4BitSELECTi : SBF generic map(
				width_inl=>5,
				width_inr=>0,
				width_outl=>4,
				width_outr=>0,
				lpm_signed=>BusIsUnsigned,
				round=>0,
				satur=>0)
		port map (
				xin=>unsignedintegerbusselect4bit,
				yout=>SAUnsgnInt4BitSELECTO);


-- Mux - Simulink Block "nto1MultiplexerFullBinary"
nto1MultiplexerFullBinaryi : sMuxAltr generic map (
				lpm_pipeline =>0,
				lpm_size =>4,
				lpm_widths =>2,
				lpm_width =>10,
				SelOneHot =>0)
		port map (
				clock		=>	'0',
				ena   		=>	'1',
				sclr   		=>	'0',
				data   		=>	data_13_muxin,
				sel   		=>	Sel_13_Mux,
				result		=>	A9W);


-- Mux - Simulink Block "nto1MultiplexerOneHot"
nto1MultiplexerOneHoti : sMuxAltr generic map (
				lpm_pipeline =>0,
				lpm_size =>4,
				lpm_widths =>4,
				lpm_width =>10,
				SelOneHot =>1)
		port map (
				clock		=>	'0',
				ena   		=>	'1',
				sclr   		=>	'0',
				data   		=>	data_14_muxin,
				sel   		=>	Sel_14_Mux,
				result		=>	A10W);


-- Bit Pattern Generator - Simulink Block "Pattern"
Patterni : seq generic map (
				SequenceLength => 4,
				SequenceValue => 1)
			port map (
				clock		=>clock,
				ena   		=>	'1',
				sclr   		=>	sclr,
				yout		=>	A11W);


-- Bit Pattern Generator - Simulink Block "Pattern1"
Pattern1i : seq generic map (
				SequenceLength => 4,
				SequenceValue => 2)
			port map (
				clock		=>clock,
				ena   		=>	'1',
				sclr   		=>	sclr,
				yout		=>	A12W);


-- Bit Pattern Generator - Simulink Block "Pattern2"
Pattern2i : seq generic map (
				SequenceLength => 4,
				SequenceValue => 4)
			port map (
				clock		=>clock,
				ena   		=>	'1',
				sclr   		=>	sclr,
				yout		=>	A13W);


-- Bit Pattern Generator - Simulink Block "Pattern3"
Pattern3i : seq generic map (
				SequenceLength => 4,
				SequenceValue => 8)
			port map (
				clock		=>clock,
				ena   		=>	'1',
				sclr   		=>	sclr,
				yout		=>	A14W);


-- DSP Builder Block - Simulink Block "IncrementDecrement"
IncrementDecrementi : IncDec  Generic map (
				lpm_width	=>	4,
				cst_val	=>	"0000",
				lpm	=>	0,
				isunsigned	=>	1,
				SequenceLength	=>	1,
				SequenceValue	=>	1,
				direction	=>	0)
		port map (
				clock	=>	clock,
				sclr	=>	sclr,
				ena	=>	'1',
				result(3 downto 0)	=>	unsignedintegerbusselect4bit(3 downto 0));


end architecture aDspBuilder;


