puts "############################################################################################"
puts "# "
puts "# DSP Builder (Version 6.0)"
puts "# Quartus II development tool and MATLAB/Simulink Interface"
puts "# "
puts "# Legal Notice:  2001 Altera Corporation. All rights reserved.  Your use of Altera  "
puts "# Corporation's design tools, logic functions and other software and tools, and its  "
puts "# AMPP partner logic functions, and any output files any of the foregoing            "
puts "# (including device programming or simulation files), and any associated             "
puts "# documentation or information are expressly subject to the terms and conditions     "
puts "# of the Altera Program License Subscription Agreement, Altera MegaCore Function     "
puts "# License Agreement, or other applicable license agreement, including, without       "
puts "# limitation, that your use is for the sole purpose of programming logic devices     "
puts "# manufactured by Altera and sold by Altera or its authorized distributors.          "
puts "# Please refer to the applicable agreement for further details.                      "
puts "#                                                                                    "
puts "#                                                                                    "
puts "############################################################################################"

# TCL Script for ModelSim 

# Set Simulation timing parameters 
set SimTime 210
set TimeResolution 1ps

# Directory Variables 
set workdir "C:/CS342Fall2006/MUX"
set libdir "c:/altera/dspbuilder/altlib"
set megadir "c:/altera/dspbuilder/megacorelib"
set bForceRecompile 0


# Close existing ModelSim simulation 
quit -sim

# Create ModelSim project 
if {[file exist [project env]] > 0} {project close}
cd $workdir
if {[file exist "$workdir/muxDemoDspBuilder.mpf"] == 0} {
	project new $workdir muxDemoDspBuilder work 
} else	{
	project open muxDemoDspBuilder
}

# Compile LPM VHDL library 
if {([file exist lpm] ==0)||($bForceRecompile>0)} {
				exec vlib lpm
				exec vmap lpm lpm
				vcom -93 -explicit -work lpm  "$libdir/220pack.vhd"
				vcom -93 -explicit -work lpm  "$libdir/220model.vhd"
				}
exec vmap lpm lpm

# Compile Megafunction VHDL library 
if {([file exist altera_mf] ==0)||($bForceRecompile>0)} {
				exec vlib altera_mf
				exec vmap altera_mf altera_mf
				vcom -93 -explicit -work altera_mf  "$libdir/altera_mf_components.vhd"
				vcom -93 -explicit -work altera_mf  "$libdir/altera_mf.vhd"
				}
exec vmap altera_mf altera_mf
# Compile Sgate VHDL libraries 
if {([file exist sgate] ==0) ||($bForceRecompile>0)}    {
	            exec vlib sgate
				exec vmap sgate sgate
             vcom -93 -explicit -work sgate  "$libdir/Sgate_pack.vhd"
             vcom -93 -explicit -work sgate  "$libdir/Sgate.vhd"
                                     }
exec vmap sgate sgate

# Compile dspbuilder VHDL library 
if {([file exist dspbuilder] ==0)||($bForceRecompile>0)}    {
	            exec vlib dspbuilder
             vcom -93 -explicit -work dspbuilder  "$megadir/SignalTapNode.vhd"
             vcom -93 -explicit -work dspbuilder  "$libdir/dspbuilderpack.vhd"
             vcom -93 -explicit -work dspbuilder  "$libdir/dspbuilder.vhd"
                                     }
exec vmap dspbuilder dspbuilder

# Create work lib  
if {[file exist work] ==0} 	{exec vlib work}


# Compile VHDL design files 
vcom -93 -explicit  -work work "$workdir/muxDemo.vhd"
vcom -93 -explicit  -work work "$workdir/tb_muxDemo.vhd"

# load simulation 
vsim -t $TimeResolution work.tb_muxDemo

# Set waveform display 
add wave -label clock /tb_muxDemo/clock
add wave -label "global reset (sclrp)" /tb_muxDemo/SystemReset
add wave  -radix dec /tb_muxDemo/AltBus10Bit
add wave  -radix dec /tb_muxDemo/BitAltBus5_10bit
add wave  -radix dec /tb_muxDemo/SelectPower24BitSELECT
add wave  -radix dec /tb_muxDemo/UnsgnInt4BitSELECT


# Run simulation 
run $SimTime ns


