//////////////////////////////////////////////////////////////////////////////////////////////
// 
// DSP Builder (Version 6.0)
// Quartus II development tool and MATLAB/Simulink Interface
// 
// Legal Notice:  2001 Altera Corporation. All rights reserved.  Your use of Altera  
// Corporation's design tools, logic functions and other software and tools, and its  
// AMPP partner logic functions, and any output files any of the foregoing            
// (including device programming or simulation files), and any associated             
// documentation or information are expressly subject to the terms and conditions     
// of the Altera Program License Subscription Agreement, Altera MegaCore Function     
// License Agreement, or other applicable license agreement, including, without       
// limitation, that your use is for the sole purpose of programming logic devices     
// manufactured by Altera and sold by Altera or its authorized distributors.          
// Please refer to the applicable agreement for further details.                      
//
//
//////////////////////////////////////////////////////////////////////////////////////////////

`timescale 1ns / 1ps

module tb_muxDemo;

// Input Signals
 reg clock;
 integer fopenok_stimuli;
 reg SystemReset;

// Output Signals
 wire [9:0] AltBus10Bit;
 integer AltBus10Bit_stimuli, AltBus10Bit_valinteger ;
 wire [9:0] BitAltBus5_10bit;
 integer BitAltBus5_10bit_stimuli, BitAltBus5_10bit_valinteger ;
 wire [3:0] SelectPower24BitSELECT;
 integer SelectPower24BitSELECT_stimuli, SelectPower24BitSELECT_valinteger ;
 wire [3:0] UnsgnInt4BitSELECT;
 integer UnsgnInt4BitSELECT_stimuli, UnsgnInt4BitSELECT_valinteger ;

 initial
   begin
      fopenok_stimuli =1;
      AltBus10Bit_stimuli = $fopen ("AltBus10Bit.txt");
      if (AltBus10Bit_stimuli==0) fopenok_stimuli=0;
      if (AltBus10Bit_stimuli==0) $display("DSP Builder Warning : unable to open input stimuli files AltBus10Bit.txt");
      BitAltBus5_10bit_stimuli = $fopen ("BitAltBus5_10bit.txt");
      if (BitAltBus5_10bit_stimuli==0) fopenok_stimuli=0;
      if (BitAltBus5_10bit_stimuli==0) $display("DSP Builder Warning : unable to open input stimuli files BitAltBus5_10bit.txt");
      SelectPower24BitSELECT_stimuli = $fopen ("SelectPower24BitSELECT.txt");
      if (SelectPower24BitSELECT_stimuli==0) fopenok_stimuli=0;
      if (SelectPower24BitSELECT_stimuli==0) $display("DSP Builder Warning : unable to open input stimuli files SelectPower24BitSELECT.txt");
      UnsgnInt4BitSELECT_stimuli = $fopen ("UnsgnInt4BitSELECT.txt");
      if (UnsgnInt4BitSELECT_stimuli==0) fopenok_stimuli=0;
      if (UnsgnInt4BitSELECT_stimuli==0) $display("DSP Builder Warning : unable to open input stimuli files UnsgnInt4BitSELECT.txt");
      #0 clock = 1'b0;
      #0 SystemReset = 1'b1;
      #80 SystemReset = 1'b0;
   end

 always
   begin
      #10.000 clock = 1;
      #10.000 clock = 0;
   end

// Write output results AltBus10Bitin AltBus10Bit.txt file
 always @(negedge clock)
   begin
      if ((SystemReset==0)&&(fopenok_stimuli==1))
         begin
            AltBus10Bit_valinteger   =   AltBus10Bit;
            $fdisplay(AltBus10Bit_stimuli,"%d",(AltBus10Bit_valinteger<512)?AltBus10Bit_valinteger:AltBus10Bit_valinteger-1024);
         end
      end

// Write output results BitAltBus5_10bitin BitAltBus5_10bit.txt file
 always @(negedge clock)
   begin
      if ((SystemReset==0)&&(fopenok_stimuli==1))
         begin
            BitAltBus5_10bit_valinteger   =   BitAltBus5_10bit;
            $fdisplay(BitAltBus5_10bit_stimuli,"%d",(BitAltBus5_10bit_valinteger<512)?BitAltBus5_10bit_valinteger:BitAltBus5_10bit_valinteger-1024);
         end
      end

// Write output results SelectPower24BitSELECTin SelectPower24BitSELECT.txt file
 always @(negedge clock)
   begin
      if ((SystemReset==0)&&(fopenok_stimuli==1))
         begin
            SelectPower24BitSELECT_valinteger   =   SelectPower24BitSELECT;
            $fdisplay(SelectPower24BitSELECT_stimuli,"%d",(SelectPower24BitSELECT_valinteger<8)?SelectPower24BitSELECT_valinteger:SelectPower24BitSELECT_valinteger-16);
         end
      end

// Write output results UnsgnInt4BitSELECTin UnsgnInt4BitSELECT.txt file
 always @(negedge clock)
   begin
      if ((SystemReset==0)&&(fopenok_stimuli==1))
         begin
            UnsgnInt4BitSELECT_valinteger   =   UnsgnInt4BitSELECT;
            $fdisplay(UnsgnInt4BitSELECT_stimuli,"%d",(UnsgnInt4BitSELECT_valinteger<8)?UnsgnInt4BitSELECT_valinteger:UnsgnInt4BitSELECT_valinteger-16);
         end
      end

// Instantiation of the Simulink model muxDemo instance name 'dut' (Device under test)
 muxDemo dut (
            .AltBus10Bit(AltBus10Bit[9:0]),
            .BitAltBus5_10bit(BitAltBus5_10bit[9:0]),
            .SelectPower24BitSELECT(SelectPower24BitSELECT[3:0]),
            .UnsgnInt4BitSELECT(UnsgnInt4BitSELECT[3:0]),
            .sclrp(SystemReset),
            .clock(clock));

endmodule

