--------------------------------------------------------------------------------------------
-- 
-- DSP Builder (Version 6.0, Build 202)
-- Quartus II development tool and MATLAB/Simulink Interface
-- 
-- Legal Notice:  2001 Altera Corporation. All rights reserved.  Your use of Altera  
-- Corporation's design tools, logic functions and other software and tools, and its  
-- AMPP partner logic functions, and any output files any of the foregoing            
-- (including device programming or simulation files), and any associated             
-- documentation or information are expressly subject to the terms and conditions     
-- of the Altera Program License Subscription Agreement, Altera MegaCore Function     
-- License Agreement, or other applicable license agreement, including, without       
-- limitation, that your use is for the sole purpose of programming logic devices     
-- manufactured by Altera and sold by Altera or its authorized distributors.          
-- Please refer to the applicable agreement for further details.                      
--
--
-- Time Stamp: Tue Aug 29 15:24:14 2006

--------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

library dspbuilder;
use dspbuilder.dspbuilderblock.all;

library lpm;
use lpm.lpm_components.all;

use std.textio.all;

Entity tb_muxDemo is 
		generic (ClockPeriod : time:= 20.00000 ns);
end tb_muxDemo;

architecture tbDspBuilder of tb_muxDemo is

	signal clock	:		std_logic 	:='0';
	signal SystemReset		:	std_logic 	:='1';
	signal sReadSimulinkStimuli		:	std_logic 	:='0';
	signal WriteStimuli		:	std_logic :='0';
	signal CountClock		:	integer 	:=0;
	signal AltBus10Bit		:	std_logic_vector(9 downto 0);
	signal BitAltBus5_10bit		:	std_logic_vector(9 downto 0);
	signal SelectPower24BitSELECT		:	std_logic_vector(3 downto 0);
	signal UnsgnInt4BitSELECT		:	std_logic_vector(3 downto 0);

	component muxDemo 
		 port(
			clock		:	in std_logic ;
			sclrp  		:	in std_logic ;
			AltBus10Bit		:	out std_logic_vector(9 downto 0);
			BitAltBus5_10bit		:	out std_logic_vector(9 downto 0);
			SelectPower24BitSELECT		:	out std_logic_vector(3 downto 0);
			UnsgnInt4BitSELECT		:	out std_logic_vector(3 downto 0));
	end component ;

Begin

	assert (1<0)  report altversion severity Note;

-- Sampling clock process generation
	ClkPr : process
	begin
		wait for ClockPeriod/2;
		clock <= not clock;
	end process ClkPr;

-- System Reset : Initialization of Altera Registers
	sReadSimulinkStimuli <='0' when (CountClock<4) else '1';

	WriteStimuli <= not SystemReset;

	ctime:process(clock)
	begin
		if clock'event and clock='0' then
			CountClock <= CountClock+1;
			SystemReset <= not sReadSimulinkStimuli;
		end if ;
	end process ctime;

-- Instantiation of the Simulink model muxDemo instance name 'dut' (Device under test)
	dut:muxDemo	port map(
					clock		=>	clock,
					sclrp  		=>	SystemReset,
					AltBus10Bit		=>	AltBus10Bit,
					BitAltBus5_10bit		=>	BitAltBus5_10bit,
					SelectPower24BitSELECT		=>	SelectPower24BitSELECT,
					UnsgnInt4BitSELECT		=>	UnsgnInt4BitSELECT);

-- Writing Output Signal "AltBus10Bit" in the file "AltBus10Bit".txt
	pAltBus10Bit:process(clock)
	file oFile 	: text open write_mode is "AltBus10Bit.txt";
	variable traceline		: line ;
	begin
		if WriteStimuli='1' then
			if clock'event and clock='1' then
				write(traceline, conv_integer(AltBus10Bit),justified=>left, field=>5);
				writeline(oFile,traceline);
			end if ;
		end if ;
	end process ;


-- Writing Output Signal "BitAltBus5_10bit" in the file "BitAltBus5_10bit".txt
	pBitAltBus5_10bit:process(clock)
	file oFile 	: text open write_mode is "BitAltBus5_10bit.txt";
	variable traceline		: line ;
	begin
		if WriteStimuli='1' then
			if clock'event and clock='1' then
				write(traceline, conv_integer(BitAltBus5_10bit),justified=>left, field=>5);
				writeline(oFile,traceline);
			end if ;
		end if ;
	end process ;


-- Writing Output Signal "SelectPower24BitSELECT" in the file "SelectPower24BitSELECT".txt
	pSelectPower24BitSELECT:process(clock)
	file oFile 	: text open write_mode is "SelectPower24BitSELECT.txt";
	variable traceline		: line ;
	begin
		if WriteStimuli='1' then
			if clock'event and clock='1' then
				write(traceline, conv_integer("0" & SelectPower24BitSELECT),justified=>left, field=>5);
				writeline(oFile,traceline);
			end if ;
		end if ;
	end process ;


-- Writing Output Signal "UnsgnInt4BitSELECT" in the file "UnsgnInt4BitSELECT".txt
	pUnsgnInt4BitSELECT:process(clock)
	file oFile 	: text open write_mode is "UnsgnInt4BitSELECT.txt";
	variable traceline		: line ;
	begin
		if WriteStimuli='1' then
			if clock'event and clock='1' then
				write(traceline, conv_integer("0" & UnsgnInt4BitSELECT),justified=>left, field=>5);
				writeline(oFile,traceline);
			end if ;
		end if ;
	end process ;



end architecture tbDspBuilder;


